> For the complete documentation index, see [llms.txt](https://docs.petal.build/petal-pro-documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.petal.build/petal-pro-documentation/fundamentals/javascript-hooks.md).

# Javascript Hooks

### Hook structure

We have set up a structure for you that makes it easy to keep adding hooks. To add a new hook:

1. `touch /assets/js/hooks/my-hook.js`
2. Make sure you export it:

```javascript
const MyHook = {
  ...
};

export default MyHook;
```

3. In `hooks/index.js`, import it:

```javascript
import MyHook from "./my-hook";

export default {
  MyHook,
};
```

It will now be available to use in your HEEX templates:

```
<div phx-hook="MyHook"></div>
```

Note that in dead views, only the `mounted()` callback will be run.&#x20;

### Hooks from Petal Pro

#### Remove flash hook

This hook pairs with the `<.flash_group>` component and will auto-dismiss a flash message after a period of time (10 seconds).

#### Resize text area hook

Textareas can be annoying to write in when your content exceeds the height and a scrollbar appears. This hook will auto-resize the textarea as you type in it - so it will never have a scroll bar in it and will keep getting bigger as you add more content.

#### Scroll top hook

Imagine you have a live view with multiple "pages" within it that you navigate via `live_patch` links. There is a bug where, if you're on say Page 1 and the content is larger than the view port and you've scrolled down somewhat - if you click a `live_patch` link to another "page", the content doesn't scroll up. So the content has changed underneath you but you're half way down the page so it's a confusing user experience. You can place `phx-hook="ScrollTopHook"` on the `live_patch` link and it will scroll the page to the top for you when you click it.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.petal.build/petal-pro-documentation/fundamentals/javascript-hooks.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
